<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=edge" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Document</title>
  </head>
  <body>
    <div id="root"></div>
    <script>
      /*
    Задание: напишите класс, создающий объект, описывающий кнопку. 
    Класс должно получать такие параметры:
    - текст кнопки;
    - id кнопки есть нужно;
    - список классов кнопки (в виде массива строк);
    - название класса, который добавляет кнопке при первом клике и убирается при повторном;
    
    У объекта должен быть метод render, который возвращает DOM-элемент, описывающий кнопку, в таком виде:
    <button class="object.classList">object.buttonText</button>
    
    Также у объекта должен быть метод handleClick, который будет привязан к событию "click" на кнопке, и будет устанавливать ей активный класс если его нет и убирать его - если он есть.
    
    В качестве аргумента класс будет принимать объект с параметрами. Пример:
    */
      class Button {
        constructor (text, id, classList, activeClass) {
          this.text = text;
          this.id = id;
          this.classList = classList;
          this.activeClass = activeClass;
          this.element = null;
        }
        render () {
        this.createElement();
        container.append(this.element);
        this.handleElementClick();
        }

        createElement () {
          this.element = document.createElement('button');
          this.element.className = this.classList.join(' ');
          this.element.innerHTML = this.text;
          this.id = this.id;
        }

        handleElementClick () {
          this.element.addEventListener('click', () => {
            this.element.classList.toggle(this.activeClass);
          })
        }
      }
      const container = document.getElementById("root");
      const button = new Button('buy', 'btn', 'btn', 'active');
      button.render();
      // class Buton {
      //   constructor(text, id, classList, activeClass) {
      //     this.text = text;
      //     this.id = id;
      //     this.classList = classList;
      //     this.activeClass = activeClass;
      //     this.element = null;
      //   }

      //   render(){
      //       ///
      //   }

      //   createElement(){
      //       this.element = document.createElement('button');
      //       this.element.className = this.classList.join(' ');
      //       this.element.innerHTML = this.text;
      //       this.element.id = this.id;
      //   }

      //   handleElementClick(){
      //     this.element.addEventListener('click', () => {
      //         this.element.classList.toggle(this.activeClass);
      //     })
      //   }
      // }
    </script>
  </body>
</html>
